
#include "Registration.h"
#include <map>
#include <string>
#include "IGenerator.h"

#include "ModuleHTTP.cpp"
#include "ModuleMath.cpp"
#include "ModuleMerge.cpp"
#include "ModuleSplitt.cpp"
#include "ModuleSQL.cpp"
#include "ModuleSwitch.cpp"

#include "ProcessorStandard.h"

namespace mdd
{
	Registration::Registration()
	{
		REGISTER(ModuleHTTP);
		REGISTER(ModuleMath);
		REGISTER(ModuleMerge);
		//REGISTER(ModuleSplitt);
		REGISTER(ModuleSQL);
		REGISTER(ModuleSwitch);

		REGISTER(ProcessorStandard);
	}
	IModule::Ptr Registration::generateModule(const std::string& name)
	{
		auto it = _gens.find(name);
		if (it != _gens.end())
		{
			return it->second->generate();
		}
		return nullptr;
	}

	std::vector<std::string> Registration::getModules() {
		std::vector<std::string> ret;
		for (auto it = _gens.begin(); it != _gens.end(); ++it)
		{
			ret.push_back(it->first);
		}
		return ret;
	}
}